
// ----- ȒPȃNX 
// O[oV{
// ::puts( object )
//   object  print čŌɉso
//
// BMX2WAV e[u
//   BMX2WAV ̊ef[^pe[u
//   Xbg
//     system( string ) -> integer
//       悭 system ֐A̋NvZX̕Wo͂eƓɂȂ
//
//     integer_to_word_string( integer ) -> string
//        BMS  Wordi36ij̕ɕϊi 17 -> "0F",  42 -> "16" j
//
//     word_string_to_integer( string ) -> integer
//       BMS  Wordi36ij̕񂩂琮ɕϊB擪2Ȃ̂ŒӁi "0F" -> 17, "16" -> 42 j
//
//     Path -> table
//       basename( string ) -> string
//       dirname( string ) -> string
//       change_extension( string, string ) -> string
//
// Searcher e[u
//   BMX2WAV Searcher ̊ef[^pe[u
//   Xbg
//     display_filters -> array
//       fBXvCtB^f[^p̔z
//
//     column_groups -> array
//       JO[vp̔z
// 
// Entry NX
//   t@C1ɑΉNX
//   e֐̈Ŏg
//   Xbg
//     path -> string
//     display_name -> string
//     type_name -> string
//     parse_as_bms_data()
//     parse_as_bms_data_once()
//     bms_data -> BmsData NX
// 
// BmsData NX
//   BMSƂẴf[^\NX
//   Xbg
//     headers -> table
//       wb_ bms_data.headers["TITLE"] ƂŎ擾
//     path -> string
//     object_count -> integer
//     object_count_of_1P -> integer
//     object_count_of_2P -> integer
//     has_random_statement -> boolean

// ----- Display Filter ֘A ---------------------------------------------
// -- DisplayFilter
class DisplayFilter {
  constructor( name ) {
    this.name = name;
  }

  function filtering( entry ) {
    return true;
  }

  name = null;
};

// -- ExtensionsFilter
class ExtensionsFilter extends DisplayFilter {
  constructor( name, ... ) {
    base.constructor( name );
    this.extensions = []
    for ( local i = 0; i < vargv.len(); i++ ) {
      this.extensions.append( vargv[i] );
    }
  }

  function filtering( entry ) {
    local low_path = entry.path.tolower();
    foreach ( extension in this.extensions ) {
      if ( ::endswith( low_path, "." + extension ) ) {
        return true;
      }
    }
    return false;
  }

  extensions = null;
};

::Searcher.display_filters.append( ExtensionsFilter( "BMSn", "bms", "bme", "bml", "pms" ) );
::Searcher.display_filters.append( ExtensionsFilter( "BMŜ", "bms" ) );
::Searcher.display_filters.append( ExtensionsFilter( "BMÊ", "bme" ) );
::Searcher.display_filters.append( {
  name = "Sĕ\",
  function filtering( entry ) {
    return true;
  }
} );


// ----- ColumnGroup ֘A ------------------------------------------------
function safety_get( table, key, default_value ) {
  return ( key in table ) ? table[key] : default_value;
}

// -- Column
class Column {
  constructor( name ) {
    this.name = name;
  }

  function display_cell( entry ) {
    return "-";
  }

  name = null;
};

// -- HeaderColumn
class HeaderColumn extends Column {
  constructor( header_name ) {
    base.constructor( "#" + header_name );
    this.header_name = header_name;
  }

  function display_cell( entry ) {
    return ::safety_get( entry.bms_data.headers, this.header_name, "-" );
  }

  header_name = null;
}

// -- PlayerColumn
class PlayerColumn extends HeaderColumn {
  constructor() {
    base.constructor( "PLAYER" );
  }

  function display_cell( entry ) {
    local tmp = base.display_cell( entry );
    switch ( tmp ) {
    case "1": return "1P";
    case "2": return "2P";
    case "3": return "DP";
    case "4": return "Battle Play";
    default:  return tmp;
    }
  }
}

// -- ObjectCountColumn
class ObjectCountColumn extends Column {
  constructor() {
    base.constructor( "IuWFNg" );
  }

  function display_cell( entry ) {
    return entry.bms_data.object_count;
  }
}

// -- ObjectOf1PCountColumn
class ObjectOf1PCountColumn extends Column {
  constructor() {
    base.constructor( "1PIuWFNg" );
  }

  function display_cell( entry ) {
    return entry.bms_data.object_count_of_1P;
  }
}

// -- ObjectOf2PCountColumn
class ObjectOf2PCountColumn extends Column {
  constructor() {
    base.constructor( "2PIuWFNg" );
  }

  function display_cell( entry ) {
    return entry.bms_data.object_count_of_2P;
  }
}

// -- ContainsRandomStatementColumn
class ContainsRandomStatementColumn extends Column {
  constructor() {
    base.constructor( "_\" );
  }

  function display_cell( entry ) {
    return entry.bms_data.has_random_statement ? "L" : "";
  }
}


// -- ColumnGroup
class ColumnGroup {
  constructor( name ) {
    this.name = name;
    this.columns = [];
  }

  name = null;
  columns = null;
};

{
  local group = ColumnGroup( "Ȉ" );
  group.columns.append( PlayerColumn() );
  group.columns.append( HeaderColumn( "GENRE" ) );
  group.columns.append( HeaderColumn( "TITLE" ) );
  group.columns.append( HeaderColumn( "ARTIST" ) );
  group.columns.append( HeaderColumn( "PLAYLEVEL" ) );
  ::Searcher.column_groups.append( group );
}

{
  local group = ColumnGroup( "ڍ" );
  group.columns.append( PlayerColumn() );
  group.columns.append( HeaderColumn( "GENRE" ) );
  group.columns.append( HeaderColumn( "TITLE" ) );
  group.columns.append( HeaderColumn( "ARTIST" ) );
  group.columns.append( HeaderColumn( "PLAYLEVEL" ) );
  group.columns.append( HeaderColumn( "BPM" ) );
  group.columns.append( ObjectOf1PCountColumn() );
  group.columns.append( ObjectOf2PCountColumn() );
  group.columns.append( ContainsRandomStatementColumn() );
  ::Searcher.column_groups.append( group );
}
